<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_RentacarCheckAvailOption ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_RentacarCheckAvailOption extends AbstractStructArrayBase
{
    /**
     * The RentacarOption
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_RentacarCheckAvailOption[]
     */
    public $RentacarOption;
    /**
     * Constructor method for ArrayOfJP_RentacarCheckAvailOption
     * @uses ArrayOfJP_RentacarCheckAvailOption::setRentacarOption()
     * @param \StructType\JP_RentacarCheckAvailOption[] $rentacarOption
     */
    public function __construct(array $rentacarOption = array())
    {
        $this
            ->setRentacarOption($rentacarOption);
    }
    /**
     * Get RentacarOption value
     * @return \StructType\JP_RentacarCheckAvailOption[]|null
     */
    public function getRentacarOption()
    {
        return $this->RentacarOption;
    }
    /**
     * This method is responsible for validating the values passed to the setRentacarOption method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRentacarOption method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRentacarOptionForArrayConstraintsFromSetRentacarOption(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_RentacarCheckAvailOptionRentacarOptionItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_RentacarCheckAvailOptionRentacarOptionItem instanceof \StructType\JP_RentacarCheckAvailOption) {
                $invalidValues[] = is_object($arrayOfJP_RentacarCheckAvailOptionRentacarOptionItem) ? get_class($arrayOfJP_RentacarCheckAvailOptionRentacarOptionItem) : sprintf('%s(%s)', gettype($arrayOfJP_RentacarCheckAvailOptionRentacarOptionItem), var_export($arrayOfJP_RentacarCheckAvailOptionRentacarOptionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RentacarOption property can only contain items of type \StructType\JP_RentacarCheckAvailOption, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RentacarOption value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_RentacarCheckAvailOption[] $rentacarOption
     * @return \ArrayType\ArrayOfJP_RentacarCheckAvailOption
     */
    public function setRentacarOption(array $rentacarOption = array())
    {
        // validation for constraint: array
        if ('' !== ($rentacarOptionArrayErrorMessage = self::validateRentacarOptionForArrayConstraintsFromSetRentacarOption($rentacarOption))) {
            throw new \InvalidArgumentException($rentacarOptionArrayErrorMessage, __LINE__);
        }
        $this->RentacarOption = $rentacarOption;
        return $this;
    }
    /**
     * Add item to RentacarOption value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_RentacarCheckAvailOption $item
     * @return \ArrayType\ArrayOfJP_RentacarCheckAvailOption
     */
    public function addToRentacarOption(\StructType\JP_RentacarCheckAvailOption $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_RentacarCheckAvailOption) {
            throw new \InvalidArgumentException(sprintf('The RentacarOption property can only contain items of type \StructType\JP_RentacarCheckAvailOption, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RentacarOption[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_RentacarCheckAvailOption|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_RentacarCheckAvailOption|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_RentacarCheckAvailOption|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_RentacarCheckAvailOption|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_RentacarCheckAvailOption|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RentacarOption
     */
    public function getAttributeName()
    {
        return 'RentacarOption';
    }
}
